clear all
clc
close all

rng('default');

N=118;
mm=1;
ms=1;
sm=0.5;
ss=0;
Links=[1 2; 1 3; 3 5; 3 9; 2 9; 4 10; 4 5; 5 6; 6 7; 7 8; 5 10; 5 11; 6 28;11 23;13 18; 13 14;14 15;17 12; 12 16; 15 16; 15 18;15 19;19 20; 19 35;34 35;33 34; 32 33;18 35;17 18;17 29;21 28;18 21;22 9; 9 23;9 10;9 24;25 26;9 25;22 29;28 20; 10 27;26 27; 26 29; 29 31; 31 30;30 32; 28 44; 26 30;26 36;30 42; 36 41; 41 39; 39 40; 40 41; 41 42; 41 44; 38 41;42 48; 42 43; 38 43;39 45; 45 46; 39 46; 47 48; 35 37;37 116;37 54; 54 55; 55 116; 55 56; 116 57; 57 58; 116 58; 96 58; 59 60; 60 61; 61 62; 62 63; 59 61; 61 64; 64 65; 61 65; 58 84; 58 90; 86 90; 65 66; 66 67; 67 68; 68 69; 69 70; 70 80; 68 81;65 68; 68 82; 68 80; 81 82; 82 83; 83 87; 90 96; 84 85;72 73; 73 71; 73 75;73 74;71 80; 71 79; 71 78; 75 76; 76 78; 77 78; 77 90; 78 90; 79 78; 85 90; 87 92; 92 89;80 89; 92 93; 88 92;92 94; 91 94;90 91; 90 92; 80 82; 80 90; 80 93;87 88; 87 82; 86 87; 86 59; 80 79; 92 95;116 96;44 96; 96 53; 96 104; 96 98; 95 98; 98 97; 101 99; 98 99; 99 117; 117 112; 117 115; 52 53; 52 100; 51 52; 51 104; 100 104; 104 46; 47 51; 106 105; 49 50; 49 109; 109 111; 110 111; 111 113; 110 113; 110 106; 110 108; 50 107; 107 108; 104 105; 104 107; 104 53; 104 101; 101 102; 101 103; 102 103; 103 114; 109 113; 104 109; 113 112; 113 114; 113 115; 114 115; 103 115; 46 47; 47 104; 115 116; 116 117; 117 118; 118 3;...
    8 9; 24 10; 56 63; 72 74; 97 93 ]';
[Lambdamu,Lambdasig, Importance]=CreateLambda(N,mm,ms,sm,ss);
while sum(Lambdamu)<0
    Lambdamu
    [Lambdamu, Lambdasig, Importance]=CreateLambda(N,mm,ms,sm,ss);
end

[SatisfiedR, EdgesR]=QuenchedWithZeta(Lambdamu,zeros(1,N),Links,0.3);
[SatisfiedA, EdgesA]=Annealed(Lambdamu,Lambdasig,Links,0.3);
[SatisfiedQ, EdgesQ]=QuenchedWithZeta(Lambdamu,Lambdasig,Links,0.3);

%Draw nodes
rng('default')
for n=1:N
    xCo(n)=rand(1);
    yCo(n)=rand(1);
end


%Draw Edges
zero=0;
for e=1:length(Links)
    zero=zero+1;
    one=1;
    line(:,zero,one)=[xCo(Links(1,e)) xCo(Links(2,e))];
    one=2;
    line(:,zero,one)=[yCo(Links(1,e)) yCo(Links(2,e))];
end

close all
figure(1)
plot(xCo,yCo,'x')
hold on 
plot(line(:,:,1),line(:,:,2),'-')

%Rubbish
GivenR=SatisfiedR-Lambdamu;
GivenA=SatisfiedA-Lambdamu;
GivenQ=SatisfiedQ-Lambdamu;

for i=1:360
    for n=1:N
        ActLam(n)=randn(1)*Lambdasig(n)+Lambdamu(n);
        HappyR(n,i)=ActLam(n)+GivenR(n);
        HappyA(n,i)=ActLam(n)+GivenA(n);
        HappyQ(n,i)=ActLam(n)+GivenQ(n);
    end
end

for n=1:N
    MissedR(n)=sum(HappyR(n,find(HappyR(n,:)<0)));
    MissedA(n)=sum(HappyA(n,find(HappyA(n,:)<0)));
    MissedQ(n)=sum(HappyQ(n,find(HappyQ(n,:)<0)));
end   
        
figure(2)
subplot(1,3,1)
BefN=plot(xCo,yCo,'k.');
hold on 
BefL=plot(line(:,:,1),line(:,:,2),'k-');
for n=1:N
    if MissedR(n)~=0
        h(n)=plot(xCo(n),yCo(n),'r.');
    end
end
set(BefL,'Color',[0.6 0.6 0.6],'LineWidth',0.2)
for n=1:N
    if MissedR(n)<0
        set(h(n),'MarkerSize',(ceil(abs(MissedR(n)))/2));
    end
end


subplot(1,3,2)
BefN=plot(xCo,yCo,'k.');
hold on 
BefL=plot(line(:,:,1),line(:,:,2),'k-');
for n=1:N
    if MissedA(n)~=0
        h(n)=plot(xCo(n),yCo(n),'r.');
    end
end
set(BefL,'Color',[0.6 0.6 0.6],'LineWidth',0.2)
for n=1:N
    if MissedA(n)<0
        set(h(n),'MarkerSize',(ceil(abs(MissedA(n)))/2));
    end
end


subplot(1,3,3)
BefN=plot(xCo,yCo,'k.');
hold on 
BefL=plot(line(:,:,1),line(:,:,2),'k-');
for n=1:N
    if MissedQ(n)~=0
        h(n)=plot(xCo(n),yCo(n),'r.');
    end
end
set(BefL,'Color',[0.6 0.6 0.6],'LineWidth',0.2)
for n=1:N
    if MissedQ(n)<0
        set(h(n),'MarkerSize',(ceil(abs(MissedQ(n)))/2));
    end
end

subplot(1,3,1)
set(gca, 'xTickLabel',[])
set(gca, 'yTickLabel',[])
set(gca, 'yTick',[])
set(gca, 'xTick',[])
title('Without')
subplot(1,3,2)
set(gca, 'xTickLabel',[])
set(gca, 'yTickLabel',[])
set(gca, 'yTick',[])
set(gca, 'xTick',[])
title('Soft Constraints')
subplot(1,3,3)
set(gca, 'xTickLabel',[])
set(gca, 'yTickLabel',[])
set(gca, 'yTick',[])
set(gca, 'xTick',[])
a=('    Soft Constraints   ');
b=('with Quenched Averaging');
c=[a;b];
title(c)
